<template>
  <div>
    <v-row class="bordered-box full-pic">
      <v-col cols="9">
        <v-img
          contain
          max-height="80%"
          :src="picture.link"
          position="center top">
        </v-img>
      </v-col>
      <v-divider class="mx-4" vertical />
      <v-col cols="3">
        <div class="full-pic__info">
          <v-avatar size="48" class="profile__avatar">
            <img
              :src="picture.owner.avatar"
              alt="Avatar"
              @click="toProfile"
            />
          </v-avatar>
          <div class="full-pic__info-top">
            <div class="full-pic__info__owner">
              {{ picture.owner.name }}
            </div>
            <div class="full-pic__info__date">
              {{ picture.dateUploaded }}
            </div>
          </div>
          <IconifyIcon
            v-if="picture.owner.id === userID"
            :icon="icons.editIcon"
            :style="{color: 'rgba(89, 89, 89, 0.9)'}"
            width="30px"
            height="30px"
            class="full-pic__edit"
            @click.stop="dialog = true"
          />
          <v-dialog
            v-model="dialog"
            max-width="600px">
            <v-card>
              <v-card-title>
                <span>Picture options</span>
              </v-card-title>
              <v-card-text>
                <v-row>
                  <v-col cols="8">
                    <v-select
                      :items="picturePrivacyOptions"
                      label="Privacy"
                      v-model="picture.privacy"
                    />
                  </v-col>
                </v-row>
                <v-row>
                  <v-col cols="10">
                    <FriendsPool
                      v-if="picture.privacy === picturePrivacyOptions[2]"
                      ref="friendsPool"
                    />
                  </v-col>
                </v-row>
              </v-card-text>
              <v-card-actions>
                <v-spacer />
                <v-btn
                  color="blue darken-1"
                  text
                  @click="dialog = false">
                  Close
                </v-btn>
                <v-btn
                  color="blue darken-1"
                  text
                  @click="SavePictureOptions"
                  :disabled="savePictureDisabled">
                  Save
                </v-btn>
              </v-card-actions>
            </v-card>
          </v-dialog>
        </div>
        <div class="full-pic__likes">
          <IconifyIcon
            :icon="picture.isLiked ? icons.likeFilled : icons.likeOutlined"
            :style="{color: 'rgba(89, 89, 89, 0.9)'}"
            width="30px"
            height="30px"
            class="full-pic__likes-icon"
            @click.stop="UpdateLike"
          />
          <div class="full-pic__likes-count">
            {{ likesCount }}
          </div>
        </div>
        <div class="full-pic__comment">
          {{ picture.comment }}
        </div>
      </v-col>
    </v-row>
    <Chat
      :chat-id="chatID"
      :picture-id="picture.id"
      :pic-owner-name="picture.owner.name"
      :pic-owner-id="picture.owner.id"
      :pic-owner-avatar="picture.owner.avatar"
      v-if="picture.owner.id"/>
  </div>
</template>

<script>
import { GetFullPicture, UpdatePictureOptions, LikePicture, UnlikePicture } from '@/api/pictures'
import { newAvatarS3Link } from "@/js/s3"
import IconifyIcon from '@iconify/vue'
import editIcon from '@iconify/icons-bytesize/edit'
import { mapGetters, mapMutations } from 'vuex'
import FriendsPool from '@/components/FriendsPool'
import Chat from '@/components/MyChat'
import likeFilled from '@iconify/icons-ant-design/like-filled'
import likeOutlined from '@iconify/icons-ant-design/like-outlined'

export default {
  name: 'FullPicture',

  components: {
    IconifyIcon,
    FriendsPool,
    Chat
  },

  data() {
    return {
      picture: {
        link: '',
        id: this.$route.query.pictureID,
        dateUploaded: '',
        isLiked: false,
        likes: '',
        privacy: '',
        comment: '',
        owner: {
          name: '',
          id: '',
          avatar: ''
        }
      },

      icons: {
        likeFilled,
        likeOutlined,
        editIcon
      },
      dialog: false,
      savePictureDisabled: false,

      chatID: ''
    }
  },

  computed: {
    ...mapGetters([
      'userID',
      'picturePrivacyOptions',
      'usersSharedWith'
    ]),

    likesCount() {
      return this.picture.likes >= 1000 ? Math.floor(this.picture.likes / 1000) + "k" : this.picture.likes
    }
  },

  methods: {
    ...mapMutations([
      'updateUsersSharedWith'
    ]),

    formatDate(time) {
      const dateStr = time.substring(0, time.lastIndexOf('T'))
      const parts = dateStr.split('-')
      const date = new Date(parseInt(parts[0]), parseInt(parts[1]) - 1, parseInt(parts[2]))
      return new Intl.DateTimeFormat('en', { day: '2-digit' }).format(date) + ' ' +
             new Intl.DateTimeFormat('en', { month: 'short' }).format(date) + ' ' +
             new Intl.DateTimeFormat('en', { year: 'numeric' }).format(date)
    },

    toProfile() {
      if (this.picture.owner.id === this.userID) {
        this.$router.push({ name: 'MyProfile' })
      } else {
        this.$router.push({ name: 'Profile', params: { userID: this.picture.owner.id } })
      }
    },

    async SavePictureOptions() {
      this.savePictureDisabled = true
      const status = await UpdatePictureOptions(this.$route.query.pictureID, {
        privacy: this.picturePrivacyOptions.indexOf(this.picture.privacy),
        sharedWith: this.usersSharedWith
      })
      this.savePictureDisabled = false

      if (!status) {
        return
      }

      if (status === 200) {
        this.$toasted.success('Successfully saved')
        this.dialog = false
        this.updateUsersSharedWith([])
      } else {
        this.$toasted.error('Oh no... Something bad happened')
      }
    },

    async UpdateLike() {
      let status
      if (this.picture.isLiked) {
        status = await UnlikePicture(this.$route.query.pictureID)
      } else {
        status = await LikePicture(this.$route.query.pictureID)
      }
      if (!status) {
        return
      }

      if (status === 200) {
        this.picture.isLiked = !this.picture.isLiked
        this.picture.likes += this.picture.isLiked ? 1 : -1
      } else {
        this.$toasted.error('Oh no... Something bad happened')
      }
    }
  },

  async created() {
    const response = await GetFullPicture(this.$route.query.pictureID)
    if (!response.status) {
      return
    }

    if (response.status !== 200) {
      this.$toasted.error('Oh no... Something bad happened')
      return
    }

    const data = response.data.data.data
    const ownerID = data.relationships.owner.data.id
    const included = response.data.data.included
    const owner = included.find(item => item.id === ownerID).attributes

    this.picture.owner.id = ownerID
    this.picture.owner.avatar = owner.has_avatar ? newAvatarS3Link(ownerID) : '/dummy.png'
    this.picture.owner.name = owner.first_name + ' ' + owner.last_name
    this.picture.dateUploaded = this.formatDate(data.attributes.created_at)
    this.picture.link = decodeURI(data.attributes.link)
    this.picture.privacy = this.picturePrivacyOptions[data.attributes.privacy]
    this.picture.likes = data.attributes.likes
    this.picture.isLiked = data.attributes.is_liked
    this.picture.comment = data.attributes.comment

    if (data.relationships.chat.data) {
      this.chatID = data.relationships.chat.data.id
    }

    if (data.attributes.privacy === 2) {
      const usersSharedWith = []
      data.relationships.shared_with.data.forEach(e => {
        const userSharedWith = included.find(item => item.id === e.id)
        usersSharedWith.push({
          text: userSharedWith.attributes.first_name + ' ' + userSharedWith.attributes.last_name,
          value: userSharedWith.id
        })
      })
      this.updateUsersSharedWith(usersSharedWith)
    }
  }
}
</script>

<style>
@import url('https://fonts.googleapis.com/css2?family=Nunito:wght@200;400;600;700&display=swap');

.full-pic {
  margin-top: 30px !important;
  margin-right: 30px !important;
  margin-left: 30px !important;
}

.v-responsive__sizer {
  padding-bottom: 70% !important;
}

.full-pic__info {
  display: flex;
  margin-top: 5px;
}

.full-pic__info__owner {
  margin-top: 5px;
  margin-left: 10px;
  font-family: 'Nunito', fantasy;
  font-style: normal;
  font-weight: 600;
  letter-spacing: .03em;
}

.full-pic__info__date {
  margin-left: 10px;
  color: rgba(51, 51, 51, 1);
  font-family: 'Nunito', fantasy;
  font-style: normal;
  font-weight: 200;
  font-size: 13px;
  letter-spacing: .03em;
}

.full-pic__edit {
  margin-left: auto;
}

.full-pic__edit:hover {
  cursor: pointer;
}

.full-pic__likes {
  display: flex;
  margin-top: 10px;
  margin-left: 10px;
}

.full-pic__likes-count {
  margin-top: 5px;
  margin-left: 5px;
  font-family: 'Nunito', fantasy;
  font-style: normal;
  font-weight: 600;
}

.full-pic__likes-icon {
  cursor: pointer;
}

.full-pic__comment {
  margin-top: 10px;
  white-space: pre-line !important;
  word-break: break-word;
  font-family: "Lucida Sans Unicode",sans-serif;
  font-size: 17px;
  font-weight: 400;
  line-height: 15px;
}

</style>
